/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : March 4, 1998                                                  */
/* File Name : 
*/
/*************************************************************************/
/*************************************************************************/

#ifndef _SETCOVERPROBLEM_H
#define _SETCOVERPROBLEM_H

#include <iostream.h>

#include <Set.h>
#include <deffunc.h>

#include "SetCover.h"
#include "Column.h"

class SetCoverProblem
{ 
  public:

     SetCoverProblem(ulong,ulong,ulong,ulong,double);

     SetCoverProblem(const SetCoverProblem&);
     ~SetCoverProblem();
     void UpdateRow(ulong,ulong,ulong,ulong,int *);

     void printRowInfo() const {printRowInfo(cout);};
     void printRowInfo(ostream&) const;


     unsigned int getNumOfCols();
     unsigned int getNumOfRows();
     Column   *getColumnWithIndx(int);
     getIndexOfSignature(char*);
     getIndexOfParSignature(int,char*);
     void sort();

     friend ostream &operator<<(ostream&,const SetCoverProblem&);

  private:

          ulong NumOfRows;
          ulong NumOfColumns;
          ulong NumberOfNonZeros;
          ulong TheBestIP;
         double TheBestLP;
    Set<Column*> myColumns;

}; // end of SetCoverProblem

#endif
